<template>
    <div class="modal" v-show="show">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Редактирование пользователя</h5>
                    <button type="button" class="close" @click="$emit('close')">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <form @submit.prevent="editEmployees">
                    <div class="modal-body">
                        <div class="mb-3">
                            <label for="company" class="form-label">Имя Компании</label>
                            <input type="text" class="form-control" id="company" v-model="localUser.company">
                            <label for="email" class="form-label">Почта</label>
                            <input type="email" class="form-control" id="email" v-model="localUser.email">
                            <label for="logo" class="form-label">Логотип</label>
                            <input type="text" class="form-control" id="logo" v-model="localUser.logo">
                            <label for="website" class="form-label">Веб-сайт</label>
                            <input type="text" class="form-control" id="website" v-model="localUser.website">
                            <label for="address" class="form-label">Адрес</label>
                            <input type="text" class="form-control" id="address" v-model="localUser.address">
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" @click="$emit('close')">Закрыть</button>
                        <button type="submit" class="btn btn-primary">Сохранить изменения</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</template>

<script>
import {mapActions} from "vuex";

export default {
    props: ['editableUser', 'show'],
    data() {
        return {
            localUser: this.createLocalUser(this.editableUser) // Создаем локального пользователя сразу
        };
    },
    watch: {
        // Отслеживаем изменения editableUser и обновляем localUser
        editableUser: {
            handler(newValue) {
                this.localUser = this.createLocalUser(newValue);
            },
            deep: true,
            immediate: true
        }
    },
    methods: {
        ...mapActions('companies', ['editUser']),
        createLocalUser(editableUser) {
            // Защита от null и undefined
            if (editableUser && editableUser.company) {
                return JSON.parse(JSON.stringify(editableUser));
            }

            return {
                company: '',
                name: '',
                position: '',
                date: '',
                phone: '',
                email: '',
                salary: ''
            };
        },
        async editEmployees() {
            await this.editUser(this.localUser);
            this.$emit('close');
        }
    },
};
</script>

<style scoped>
.modal {
    display: flex;
    align-items: center;
    justify-content: center;
}

.modal-dialog {
    margin: auto;
}
</style>
